import { ElementRef } from '@angular/core';
import { RenderOptions } from './js-wrapper/renderOptions.model';
import { PdfWrapper } from './js-wrapper/pdf-wrapper';
import { PdfAnnotateWrapper } from './js-wrapper/pdf-annotate-wrapper';
import { BehaviorSubject, Subject } from 'rxjs';
import { EmLoggerService } from '../logging/em-logger.service';
import { RotationModel } from '../model/rotation-factory.model';
export declare class PdfRenderService {
    private pdfWrapper;
    private log;
    private pdfAnnotateWrapper;
    private viewerElementRef;
    private RENDER_OPTIONS;
    private pdfPages;
    private dataLoadedSubject;
    listPagesSubject: Subject<RotationModel[]>;
    listPages: RotationModel[];
    constructor(pdfWrapper: PdfWrapper, log: EmLoggerService, pdfAnnotateWrapper: PdfAnnotateWrapper);
    getDataLoadedSub(): BehaviorSubject<boolean>;
    dataLoadedUpdate(isLoaded: boolean): void;
    getRenderOptions(): RenderOptions;
    setRenderOptions(RENDER_OPTIONS: RenderOptions): any;
    getViewerElementRef(): ElementRef;
    getPdfPages(): number;
    render(viewerElementRef?: ElementRef): void;
    addDomPage(pageDom: any, pageNumber: number): void;
    getPageRotation(renderOptions: RenderOptions, pageOptions: RenderOptions, pdfPage: any): number;
}
